<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import { useBillCostStore } from '@/stores/billcost'
import { useTypebillcostStore } from '@/stores/typebillcost'
import DialogAddBillCost from './DialogAddBillCost.vue'
import DialogEditBillCost from './DialogEditBillCost.vue'
import ReportBillCost from './ReportBillCost.vue'
import { onMounted, ref } from 'vue'
const search = ref('')
const authStore = useAuthStore()
const typebillcostStore = useTypebillcostStore()
const billcostStore = useBillCostStore()
const headers = [
  // {
  //   key: 'id',
  //   sortable: false,
  //   title: 'BillCostId'
  // },
  { key: 'Typebillcost', title: 'TypeBill', sortable: false, value: 'typebillcost.name' },
  { key: 'User', title: 'User', sortable: false, value: 'user.fullName' },
  { key: 'Date', title: 'Date', sortable: false, value: 'date' },
  { key: 'Time', title: 'Time', sortable: false, value: 'time' },
  { key: 'Billtotal', title: 'BillTotal (Baht)', sortable: false, value: 'billtotal' },
  { key: 'branch', title: 'Branch', sortable: false, value: 'branch.id' },
  { key: 'actions', title: 'Actions', sortable: false }
]

onMounted(async () => {
  // await billcostStore.getBillCosts()
  await typebillcostStore.getTypebillcosts()
  if (authStore.getCurrentUser()?.role === 'Staff') {
    const userId = authStore.getCurrentUser()?.id
    if (userId) {
      await billcostStore.getBillCostsByUser(userId)
    }
  } else if (authStore.getCurrentUser()?.role === 'Manager') {
    const branchId = authStore.getCurrentUser()?.branch?.id
    if (branchId) {
      await billcostStore.getBillCostsByBranch(branchId)
    }
  } else if (authStore.getCurrentUser()?.role === 'Owner') {
    await billcostStore.getBillCosts()
  }
})
</script>

<template>
  <div>
    <v-data-table
      v-model:search="search"
      :headers="headers"
      :items="billcostStore.billCosts"
      height="664"
    >
      <template v-slot:top>
        <v-toolbar flat style="background-color: #282828; color: white">
          <v-toolbar-title>BILL COST</v-toolbar-title>
          <v-spacer></v-spacer>
          <v-text-field
            v-model="search"
            prepend-inner-icon="mdi-magnify"
            density="compact"
            label="Search"
            single-line
            flat
            hide-details
            variant="solo-filled"
            style="width: 1px; margin-right: 10px"
          ></v-text-field>

          <v-btn
            style="background-color: #c7a17a; margin-right: 10px"
            color="white"
            @click="billcostStore.openDialog"
            v-if="authStore.getCurrentUser()?.role === 'Staff'"
          >
            ADD BILL COST
          </v-btn>
          <v-btn
            style="background-color: #c7a17a; margin-right: 10px"
            color="white"
            @click="billcostStore.openDialogReport"
            v-if="
              authStore.getCurrentUser()?.role === 'Manager' ||
              authStore.getCurrentUser()?.role === 'Owner'
            "
          >
            REPORT BILL COST
          </v-btn>
        </v-toolbar>

        <v-dialog v-model="billcostStore.imageDialog">
          <v-card>
            <v-card-title> Image BillCosr </v-card-title>
            <v-col cols="12" md="12" class="d-flex justify-center">
              <v-img
                :src="
                  'http://localhost:3000/images/billcosts/' + billcostStore.editedbillCost.image
                "
                height="600"
                width="600"
              ></v-img>
            </v-col>
            <v-card-actions>
              <v-btn color="red" variant="text" @click="billcostStore.closeimageDialog"
                >Cancel</v-btn
              >
            </v-card-actions>
          </v-card>
        </v-dialog>

        <v-dialog v-model="billcostStore.dialogDelete" max-width="500px">
          <v-card
            class="justify-center align-center"
            style="border: #fe0000 solid 2px; border-radius: 50px"
          >
            <v-card-text>
              <v-row class="justify-center align-center pa-5"
                ><v-icon icon="mdi-delete-empty" size="120" color="#fe0000"></v-icon
              ></v-row>
              <h3>Are you sure you want to delete this item?</h3>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="red" variant="text" @click="billcostStore.closeDelete">Cancel</v-btn>
              <v-btn color="blue-darken-1" variant="text" @click="billcostStore.deleteItemConfirm"
                >OK</v-btn
              >
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="billcostStore.openimageDialog(item)">
          mdi-camera
        </v-icon>
        <!-- <v-icon size="small" class="me-2" @click="billcostStore.editItem(item)">
          mdi-pencil
        </v-icon> -->
        <!-- <v-icon size="small" class="me-2" @click="billcostStore.deleteItem(item)"
          >mdi-delete</v-icon
        > -->
      </template>
    </v-data-table>
    <DialogAddBillCost></DialogAddBillCost>
    <DialogEditBillCost></DialogEditBillCost>
    <ReportBillCost></ReportBillCost>
  </div>
</template>
